/* get_lam_phi.c - Convert (x,y) into (lam,phi) using the cylindrical
 *                 equidistant projection
 *
 * Copyright (C) 2005 - 2006
 *                    Joern Wilms
 *                    Robert Dowse
 *                    Robert Swain
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "../druantia.h"
#include "common.h"

int get_lam_phi(main_t *main, int x, int y, coords_t *coords){

  // Find the longitude for the centre of the pixel
  coords->lam = main->lam0 + main->deg_per_pix*((double)x - (main->width-1)/2.0);
  // Find the latitude for the centre of the pixel
  coords->phi = main->phi0  +main->deg_per_pix*((double)y - (main->height-1)/2.0);

  return(OK);
}
