/* imglib.h - Useful structs and definitions for imglib
 *
 * Copyright (C) 2005 - 2006
 *                    Joern Wilms
 *                    Robert Dowse
 *                    Robert Swain
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#include <inttypes.h>

#ifndef _IMGLIB_H
#define _IMGLIB_H

typedef struct {

  int width, height;
  char *name;

} bitmap_t;

typedef struct {

  int r, g, b;

} pixel_t;

uint8_t *bmp_init(bitmap_t *bitmap);
int bmp_set_pixel_rgb(bitmap_t *bitmap, uint8_t *bmp, pixel_t *pixel, int bmp_x, int bmp_y);
int png_write(bitmap_t *bitmap, uint8_t *bmp);

#endif
