/* wrap_lam_phi.c - A function that makes sure that all longitudes and latitudes
 *                 are in the correct ranges.
 *
 * Copyright (C) 2005 - 2006
 *                    Joern Wilms
 *                    Robert Dowse
 *                    Robert Swain
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "../druantia.h"
#include "common.h"

int wrap_lam_phi(coords_t *coords){

  double lamsign = 1.0, phisign = 1.0;

  if(coords->lam < -180.0){
    coords->lam = abs(coords->lam);
    lamsign = -1.0;
  }

  if(coords->phi < -90.0){
    coords->phi = abs(coords->phi);
    phisign = -1.0;
  }

  coords->phi = fmod(coords->phi + 90.0, 360.0);

  if(coords->phi >= 180.0){
    coords->phi = phisign * (270.0 - coords->phi);
    coords->lam = coords->lam + 180.0;
    coords->lam = lamsign * (fmod(coords->lam + 180.0, 360.0) - 180.0);
  }
  else{
    coords->phi = phisign * (coords->phi - 90.0);
    coords->lam = lamsign * (fmod(coords->lam + 180.0, 360.0) - 180.0);
  }

  return(OK);
}
