/* xyz_to_height.c - A function to find convert the camera position in (x,y,z) into
 *                   a radial height
 *
 * Copyright (C) 2005 - 2006
 *                    Joern Wilms
 *                    Robert Dowse
 *                    Robert Swain
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "../druantia.h"
#include "common.h"

double xyz_to_height(main_t *main, const double *_curpos){

  double scale_factor = main->scale*INS_TO_M/(double)main->dpi;
  double x,y,z;

  // calculate the x,y,z coords in metres relative to the centre of the planet
  x = (_curpos[0] - (double)(main->width >>1))*scale_factor;
  y = (_curpos[1] - (double)(main->height>>1))*scale_factor;
  z =  _curpos[2]                             *scale_factor;

  return sqrt(x*x + y*y + z*z); // distance from centre of planet to camera

}
