/* imgtest.c - A program to test the image library (imglib)
 *
 * Copyright (C) 2005 - 2006
 *                    Joern Wilms
 *                    Robert Dowse
 *                    Robert Swain
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */

#include <stdio.h>
#include <stdlib.h>

#include <png.h>

#include "../druantia.h"
#include "../common/imglib/imglib.h"

int main() {

  int i, j;
  unsigned char *bmp;
  bitmap_t bitmap;
  pixel_t pixel;

  bitmap.width = 640;
  bitmap.height = 480;
  bitmap.name = "testimage.png";

  if((bmp = bmp_init(&bitmap)) == NULL){
    printf("Bitmap initialisation failed\n");
    return(ERROR);
  }

  for(i=0; i<bitmap.height; i++){
    for(j=0; j<bitmap.width; j++){

      // just some random functions to generate a pretty picture :)
      pixel.r = 255.0*(double)i/bitmap.height;
      pixel.g = 255.0*(double)i*j/(bitmap.height*bitmap.width);
      pixel.b = 255.0*(double)j/bitmap.width;

      if(bmp_set_pixel_rgb(&bitmap, bmp, &pixel, j, i)){
        printf("Failed to set RGB of pixel (%d,%d)\n",j,i);
        return(ERROR);
      }
    }
  }

  if(png_write(&bitmap, bmp)){
    printf("PNG output failed\n");
    return(ERROR);
  }

  return(OK);

}
